#pragma once

#include "Reader.h"

namespace armarx::armem::articulated_object
{

    class ArticulatedObjectReader : virtual public Reader
    {
    public:
        using Reader::Reader;

        VirtualRobot::RobotPtr getArticulatedObject(const std::string& typeName,
                                                    const armem::Time& timestamp,
                                                    const std::optional<std::string>& providerName,
                                                    const std::string& instanceName = "");

        [[nodiscard]] bool
        synchronizeArticulatedObject(VirtualRobot::Robot& object,
                                     const armem::Time& timestamp,
                                     const std::optional<std::string>& providerName);
    };
} // namespace armarx::armem::articulated_object
